package org.rcisoft;

import org.rcisoft.business.device.assets.service.BusDeviceService;
import org.rcisoft.business.mainte.fault.service.BusDeviceFaultService;
import org.rcisoft.business.manage.dao.BusDevicetpParamRepository;
import org.rcisoft.business.manage.dao.ProjectRepository;
import org.rcisoft.business.manage.entity.BusProject;
import org.rcisoft.business.totaloriginal.service.TotalOriginalService;
import org.rcisoft.core.service.RcRedisService;
import org.rcisoft.mqttclient.MqttClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;
import tk.mybatis.mapper.entity.Example;

import java.util.List;

@Component
public class ZhnyLineRunner implements CommandLineRunner {
    @Autowired
    private RcRedisService rcRedisService;
    @Autowired
    private TotalOriginalService totalOriginalServiceImpl;
    @Autowired
    private ProjectRepository projectRepository;
    @Autowired
    private BusDevicetpParamRepository busDevicetpParamRepository;
    @Autowired
    BusDeviceFaultService busdeviceFaultServiceImpl;
    @Autowired
    BusDeviceService busDeviceServiceImpl;

    @Override
    public void run(String... var1) throws Exception{
        // 查出所有项目的开关状态，放入redis
//        this.searchProject();

        System.out.println("MQTT 客户端启动++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
        MqttClient client = new MqttClient(rcRedisService,totalOriginalServiceImpl, busDevicetpParamRepository, busdeviceFaultServiceImpl, busDeviceServiceImpl);
//        client.start();
    }

    private void searchProject() {
        Example example = new Example(BusProject.class);
        Example.Criteria criteria = example.createCriteria();
        criteria.andEqualTo("receiveData", 1);
        List<BusProject> list = projectRepository.selectByExample(example);
        list.forEach(busProject -> {
            rcRedisService.set("proId-" + busProject.getProId(), busProject.getReceiveData().toString());
            // list中放入需要接收数据的proId
//            rcRedisService.setList("proIds", busProject.getProId());
        });
    }
}


